m=10;
k=6;
p=0.4;
Ntot=1000;

q=1-p;rho=q/p;S_fin=zeros(Ntot,1);T_fin=zeros(Ntot,1);
for N=1:Ntot
    n=1;S=k;
    while S(n)<>0 & S(n)<>m
        n=n+1;
        S(n)=S(n-1)+2*grand(1,1,'bin',1,p)-1;
    end
S_fin(N)=S(n);
T_fin(N)=n-1;
end

prob_emp=length(S_fin(S_fin==0))/Ntot;
esp_emp=mean(T_fin);

if p=0.5 then
    prob_theo=1-k/m;
    esp_theo=k*(m-k);
else
    prob_theo=1-(1-rho^k)/(1-rho^m);
    esp_theo=m*((1-rho^k)/(1-rho^m)-k/m)/(p-q);
end

'Ecart entre les probas empirique et theorique de sortie en 0:'
abs(prob_emp-prob_theo)
'Ecart entre les espérances empirique et theorique du temps de sortie en 0 :'
abs(esp_emp-esp_theo)
