n_tot=1000;
M=zeros(n_tot,1);
X=grand(n_tot+1,1,"nor",0,1);

M(1)=X(1)*X(2);
for n=2:n_tot
    M(n)=M(n-1)+X(n)*X(n+1)/n;
end

plot2d(M)

//On a convergence presque sure de la martingale M
//En effet, chaque trajectoire converge "a l'oeil nu"

n_tot=1000;
N=zeros(n_tot,1);
X=grand(n_tot+1,1,"nor",0,1);

N(1)=X(1)*X(2);
for n=2:n_tot
    N(n)=N(n-1)+X(n)*X(n+1)/sqrt(n);
end

plot2d(N)

//Ici, les trajectoires ne convergent pas. La convergence n'a donc pas lieu p.s.

n_tot=100;
K=10000;
N=zeros(n_tot,K);
X=grand(n_tot+1,K,"nor",0,1);

N(1,:)=X(1,:).*X(2,:);
for n=2:n_tot
    N(n,:)=N(n-1,:)+X(n,:).*X(n+1,:)/sqrt(n);
end

histplot(floor(sqrt(K)),N(n_tot,:))

//On observe ici qu'au temps n_tot, la loi de N ressemble a une gaussienne
//On vient de mettre en evidence la convergence en loi de N
