function Y=tildeQ(X)//Génère une réalisation de la loi uniforme demandée
    Y=X;
    k=grand(1,1,"uin",0,length(X));
    if k>0 then
        Y(k)=-Y(k);
    end
endfunction

function H=hamilt(X)
    H=0;k=length(X)
    for i=1:k
        for j=1:k
            if j>=i then
                H=H-X(i)*X(j)
            end
        end
    end
endfunction

X=2*grand(11,11,'bin',1,0.5)-1;
function X=MCMC(n,X,beta)//Génère la X_n en fonction de X_0=X et beta
    U=rand(1,n)
    for k=1:n
        Y=tildeQ(X);R=min(1,exp(beta*hamilt(X)-beta*hamilt(Y)))
        if U<R then
            X=Y;
        end
    end
endfunction

